//+------------------------------------------------------------------+
//|                                          CountBarsFromEvents.mq4 |
//|                                      Copyright  2012, realtrade |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, realtrade"

// This indicator counts the bars from when an event/setup happend last time. When the event happens again it sets the counter back to zero
// at the open of the next bar,so if needed, an EA could still read out the counted bars and work with it.

#property indicator_chart_window

extern int BarsToLookBack  = 100;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  i;
   int  counthigh ;
   int  countlow ;
  
   for(i = BarsToLookBack; i >=0; i--)
      {
      
       if ( iHigh(NULL,0,i+1) == iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,20,i+1)) )  // set to "i+1" to be able to read out the counted bars till next bars open
          
          counthigh = 0;                                                                                  // counter set back to zero 
          
       if ( iLow(NULL,0,i+1) == iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,20,i+1)) )      // set to "i+1" to be able to read out the counted bars till next bars open
          
          countlow = 0;                                                                                   // counter set back to zero  
           
       if ( iHigh(NULL,0,i) < iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,20,i)) )
          
          counthigh++; 
          
       if ( iLow(NULL,0,i) > iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,20,i)) )
          
          countlow++;  
           
       }
   
   Comment("\n High = ",counthigh,
           "\n Low = ",countlow);
   
   
   return(0);
  }
//+------------------------------------------------------------------+